/*
Camper Jack created by Bill Corey 23-Feb-2023
This app was written to be used with an ESP32 Bluetooth or WiFi
board using Bluetooth to operate two relays to either raise or 
lower the jacks on my 5th wheel camper using an App on my phone.
The app for the phone was created using the MIT App Inventor and
is used to send either a 1 or 2 to the ESP32 to trigger the relays. 
 If either button is selected and neither are at a state of OH 
 (which is LOW on these relay modules,) that relay will be turned
 on. If either relay is on and either button is selected that will
 turn either relay off. 
 So if both are off and up is slected the up relay will activate.
    if the up or down relay are activated by selecting the up or
    down button on the Android App will de-activate the relay. 
 This ensures that both relays can not be activated at the same time
 and allows stopping the camper jacks by selecting either botton on 
 the App. 
*/

#include "BluetoothSerial.h"

int upButton   = 14;
int downButton = 13;
char received = 0;
int upButtonState = 0;
int downButtonState = 0;

BluetoothSerial SerialBT;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  pinMode(upButton,OUTPUT);
  pinMode(downButton,OUTPUT);
//****** Doesn't make sense, but HIGH is off on the relay module. ******//
  digitalWrite(upButton,HIGH);
  digitalWrite(downButton,HIGH);
  SerialBT.begin("CamperJack"); //Bluetooth device name
  Serial.println("The device started, now you can pair it with bluetooth!");
}

void loop() {
  if (Serial.available()) {
    SerialBT.write(Serial.read());
  }
  if (SerialBT.available()) { 
    received = SerialBT.read();
    Serial.print("The value of received = ");
    Serial.println(received);
    Serial.write(SerialBT.read());
  }
////////// Up Button //////////
  if (upButtonState == 0 && received == '1' && downButtonState != 1)
  {
    Serial.println("Up Button ON");
    digitalWrite(upButton,LOW);
    received = 0;
    upButtonState = 1;
  }
  if (upButtonState == 1 && received >= '1' )
  {
    Serial.println("Up Button OFF");
    digitalWrite(upButton,HIGH);
    received = 0;
    upButtonState = 0;
  }
////////// Down Button //////////
  if (downButtonState == 0 && received == '2' && upButtonState != 1)
  {
    Serial.println("Down Button ON");
    digitalWrite(downButton,LOW);
    received = 0;
    downButtonState = 1;
  }
  if (downButtonState == 1 && received >= '1')
  {
    Serial.println("Down Button OFF");
    digitalWrite(downButton,HIGH);
    received = 0;
    downButtonState = 0;
  }
  delay(20);
}
